import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React from 'react';
import classnames from 'classnames';
import { createNamespace } from '../utils';
import { BORDER_TOP_BOTTOM } from '../utils/constant';

var _createNamespace = createNamespace('cell-group'),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];

var CellGroup = function CellGroup(props) {
  var title = props.title,
      border = props.border,
      inset = props.inset;

  var renderGroup = function renderGroup() {
    return /*#__PURE__*/React.createElement("div", {
      className: classnames(bem({
        inset: inset
      }), _defineProperty({}, BORDER_TOP_BOTTOM, !inset && border))
    }, props.children);
  };

  var renderTitle = function renderTitle() {
    return /*#__PURE__*/React.createElement("div", {
      className: classnames(bem('title'))
    }, title);
  };

  if (title) return /*#__PURE__*/React.createElement(React.Fragment, null, renderTitle(), renderGroup());
  return renderGroup();
};

CellGroup.defaultProps = {
  border: true
};
export default CellGroup;