import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/* eslint-disable @typescript-eslint/naming-convention */

/* eslint-disable no-underscore-dangle */

/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import { useCallback, useRef } from 'react';
var MIN_DISTANCE = 10;

function getDirection(x, y) {
  if (x > y && x > MIN_DISTANCE) {
    return 'horizontal';
  }

  if (y > x && y > MIN_DISTANCE) {
    return 'vertical';
  }

  return '';
}

var useTouch = function useTouch() {
  var state = useRef({
    startX: 0,
    startY: 0,
    deltaX: 0,
    deltaY: 0,
    offsetX: 0,
    offsetY: 0,
    direction: ''
  });
  var deltaYRef = useRef(0);
  var isVertical = useCallback(function () {
    return state.current.direction === 'vertical';
  }, [state.current.direction]);
  var isHorizontal = useCallback(function () {
    return state.current.direction === 'horizontal';
  }, [state.current.direction]);

  var reset = function reset() {
    state.current.deltaX = 0;
    state.current.deltaY = 0;
    state.current.offsetX = 0;
    state.current.offsetY = 0;
    state.current.direction = '';
    deltaYRef.current = 0;
  };

  var start = function start(event) {
    reset();
    state.current.startX = event.touches[0].clientX;
    state.current.startY = event.touches[0].clientY;
  };

  var move = function move(event) {
    var touch = event.touches[0]; // Fix: Safari back will set clientX to negative number

    state.current.deltaX = touch.clientX < 0 ? 0 : touch.clientX - state.current.startX;
    state.current.deltaY = touch.clientY - state.current.startY;
    state.current.offsetX = Math.abs(state.current.deltaX);
    state.current.offsetY = Math.abs(state.current.deltaY);
    deltaYRef.current = state.current.deltaY;

    if (!state.current.direction) {
      state.current.direction = getDirection(Math.abs(state.current.offsetX), Math.abs(state.current.offsetY));
    }
  };

  return _objectSpread(_objectSpread({}, state.current), {}, {
    move: move,
    start: start,
    reset: reset,
    deltaYRef: deltaYRef,
    isVertical: isVertical,
    isHorizontal: isHorizontal
  });
};

export default useTouch;