import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useMemo } from 'react';
import classnames from 'classnames';
import { addUnit, createNamespace, getSizeStyle } from '../utils';

var _createNamespace = createNamespace('loading'),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];

var SpinIcon = [];

for (var i = 0; i < 12; i += 1) {
  SpinIcon.push( /*#__PURE__*/React.createElement("i", {
    key: i
  }));
}

var CircularIcon = /*#__PURE__*/React.createElement("svg", {
  className: classnames(bem('circular')),
  viewBox: "25 25 50 50"
}, /*#__PURE__*/React.createElement("circle", {
  cx: "50",
  cy: "50",
  r: "20",
  fill: "none"
}));
var BallIcon = /*#__PURE__*/React.createElement("div", {
  className: classnames(bem('ball'))
}, /*#__PURE__*/React.createElement("div", null), /*#__PURE__*/React.createElement("div", null), /*#__PURE__*/React.createElement("div", null));
var Icon = {
  spinner: SpinIcon,
  circular: CircularIcon,
  ball: BallIcon
};

var Loading = function Loading(props) {
  var className = props.className,
      type = props.type,
      vertical = props.vertical,
      color = props.color,
      size = props.size,
      textColor = props.textColor,
      children = props.children,
      textSize = props.textSize;
  var spinnerStyle = useMemo(function () {
    return _objectSpread({
      color: color
    }, getSizeStyle(size));
  }, [color, size]);

  var renderText = function renderText() {
    if (children) {
      return /*#__PURE__*/React.createElement("span", {
        className: classnames(bem('text')),
        style: {
          fontSize: addUnit(textSize),
          color: textColor !== null && textColor !== void 0 ? textColor : color
        }
      }, children);
    }

    return null;
  };

  return /*#__PURE__*/React.createElement("div", {
    className: classnames(className, bem([type, {
      vertical: vertical
    }]))
  }, /*#__PURE__*/React.createElement("span", {
    className: classnames(bem('spinner', type)),
    style: spinnerStyle
  }, Icon[type]), renderText());
};

Loading.defaultProps = {
  type: 'circular'
};
export default Loading;