import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
var _excluded = ["parent"];
import React, { useContext, useMemo } from 'react';
import RadioContext from './RadioContext';
import Checker from '../checkbox/Checker';
import { createNamespace } from '../utils';

var _createNamespace = createNamespace('radio'),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];

var Radio = function Radio(props) {
  var _useContext = useContext(RadioContext),
      parent = _useContext.parent,
      context = _objectWithoutProperties(_useContext, _excluded);

  var checked = useMemo(function () {
    return parent ? context.checked === props.name : props.checked;
  }, [context.checked]);

  var toggle = function toggle() {
    var emitter = parent ? context.toggle : function () {};
    emitter(props.name);
  };

  return /*#__PURE__*/React.createElement(Checker, _extends({}, props, {
    bem: bem,
    role: "radio",
    parent: parent,
    checked: checked,
    onToggle: toggle
  }));
};

export default Radio;