import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

/* eslint-disable no-console */
import React from 'react';
import classnames from 'classnames';
import useMergedState from '../hooks/use-merged-state';
import RadioContext from './RadioContext';
import { createNamespace } from '../utils';

var _createNamespace = createNamespace('radio-group'),
    _createNamespace2 = _slicedToArray(_createNamespace, 1),
    bem = _createNamespace2[0];

var RadioGroup = function RadioGroup(props) {
  var _useMergedState = useMergedState({
    value: props.value,
    defaultValue: props.defaultValue
  }),
      _useMergedState2 = _slicedToArray(_useMergedState, 2),
      checked = _useMergedState2[0],
      setChecked = _useMergedState2[1];

  var toggle = function toggle(name) {
    var _props$onChange;

    setChecked(name);
    (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, name);
  };

  return /*#__PURE__*/React.createElement(RadioContext.Provider, {
    value: {
      parent: {
        props: props
      },
      toggle: toggle,
      checked: checked
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames(props.className, bem([props.direction])),
    style: props.style,
    role: "radiogroup"
  }, props.children));
};

export default RadioGroup;