"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _icon = _interopRequireDefault(require("../icon"));

var _loading = _interopRequireDefault(require("../loading"));

var _popup = _interopRequireDefault(require("../popup"));

var _Popup = require("../popup/Popup");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _createNamespace = (0, _utils.createNamespace)('action-sheet'),
    _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
    bem = _createNamespace2[0];

var ActionSheet = function ActionSheet(props) {
  var onCancel = function onCancel() {
    var _props$onClose, _props$onCancel;

    (_props$onClose = props.onClose) === null || _props$onClose === void 0 ? void 0 : _props$onClose.call(props);
    (_props$onCancel = props.onCancel) === null || _props$onCancel === void 0 ? void 0 : _props$onCancel.call(props);
  };

  var renderHeader = function renderHeader() {
    if (!props.title) return null;
    return /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('header'))
    }, props.title, props.closeable && (typeof props.closeIcon === 'string' ? /*#__PURE__*/_react().default.createElement(_icon.default, {
      name: props.closeIcon,
      className: (0, _classnames().default)(bem('close')),
      onClick: onCancel
    }) : /*#__PURE__*/_react().default.createElement("div", {
      className: (0, _classnames().default)(bem('close')),
      onClick: onCancel
    }, props.closeIcon)));
  };

  var renderCancel = function renderCancel() {
    if (!props.cancelText) return null;
    return [/*#__PURE__*/_react().default.createElement("div", {
      key: "cancel-gap",
      className: (0, _classnames().default)(bem('gap'))
    }), /*#__PURE__*/_react().default.createElement("button", {
      key: "cancel-btn",
      type: "button",
      className: (0, _classnames().default)(bem('cancel')),
      onClick: onCancel
    }, props.cancelText)];
  };

  var renderOption = function renderOption(item, index) {
    var name = item.name,
        color = item.color,
        subname = item.subname,
        loading = item.loading,
        callback = item.callback,
        disabled = item.disabled,
        className = item.className,
        style = item.style;
    var Content = loading ? /*#__PURE__*/_react().default.createElement(_loading.default, {
      className: (0, _classnames().default)(bem('loading-icon'))
    }) : [/*#__PURE__*/_react().default.createElement("span", {
      key: "".concat(index, "-1"),
      className: (0, _classnames().default)(bem('name'))
    }, name), subname && /*#__PURE__*/_react().default.createElement("div", {
      key: "".concat(index, "-2"),
      className: (0, _classnames().default)(bem('subname'))
    }, subname)];

    var onClick = function onClick() {
      if (disabled || loading) {
        return;
      }

      if (callback) {
        callback(item);
      }

      if (props.closeOnClickAction) {
        onCancel();
      }

      setTimeout(function () {
        var _props$onSelect;

        (_props$onSelect = props.onSelect) === null || _props$onSelect === void 0 ? void 0 : _props$onSelect.call(props, item, index);
      }, 0);
    };

    return /*#__PURE__*/_react().default.createElement("button", {
      key: index,
      type: "button",
      style: _objectSpread({
        color: color
      }, style),
      className: (0, _classnames().default)(bem('item', {
        loading: loading,
        disabled: disabled
      }), className),
      onClick: onClick
    }, Content);
  };

  var renderDescription = function renderDescription() {
    if (props.description) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('description'))
      }, props.description);
    }

    return null;
  };

  var renderOptions = function renderOptions() {
    if (props.actions) {
      return props.actions.map(renderOption);
    }

    return null;
  };

  return /*#__PURE__*/_react().default.createElement(_popup.default, (0, _extends2().default)({
    visible: props.visible,
    className: (0, _classnames().default)(bem()),
    position: "bottom"
  }, (0, _utils.pick)(props, _Popup.sharedPopupProps), {
    onClose: onCancel,
    closeable: false
  }), renderHeader(), renderDescription(), /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('content'))
  }, renderOptions(), props.children), renderCancel());
};

ActionSheet.defaultProps = {
  closeIcon: 'cross',
  closeable: true,
  safeAreaInsetBottom: true,
  round: true,
  lockScroll: true,
  overlay: true,
  closeOnClickOverlay: true
};
var _default = ActionSheet;
exports.default = _default;