"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _enzyme() {
  var data = require("enzyme");

  _enzyme = function _enzyme() {
    return data;
  };

  return data;
}

function _enzymeToJson() {
  var data = _interopRequireDefault(require("enzyme-to-json"));

  _enzymeToJson = function _enzymeToJson() {
    return data;
  };

  return data;
}

var _index = _interopRequireDefault(require("../index"));

describe('Button', function () {
  it('should emit click event', function () {
    var onClick = jest.fn();
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
      onClick: onClick
    }, "Click"));
    wrapper.simulate('click');
    expect(onClick).toBeCalled();
  });
  it('should not emit click event when disabled', function () {
    var onClick = jest.fn();
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
      disabled: true,
      onClick: onClick
    }, "disabled"));
    wrapper.simulate('click');
    expect(onClick).not.toBeCalled();
  });
  it('should not emit click event when loading', function () {
    var onClick = jest.fn();
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
      loading: true,
      onClick: onClick
    }, "loading"));
    wrapper.simulate('click');
    expect(onClick).not.toBeCalled();
  });
  it('should hide border when color is gradient', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
      color: "linear-gradient(#000, #fff)"
    }));
    expect(wrapper.getDOMNode().style.border).toEqual('0px');
  });
  it('should change icon class prefix when using icon-prefix prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
      icon: "success",
      iconPrefix: "my-icon"
    }));
    expect((0, _enzymeToJson().default)(wrapper.html())).toMatchSnapshot();
  });
  it('should render loading of a specific size when using loading-size prop', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
      loading: true,
      loadingSize: "10px"
    }));
    var loading = wrapper.find('.rc-loading__spinner');
    expect(loading.getDOMNode().style.width).toEqual('10px');
    expect(loading.getDOMNode().style.height).toEqual('10px');
  });
  it('should render icon in the right side when setting icon-position to right', function () {
    var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
      icon: "plus",
      iconPosition: "right"
    }));
    expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
  });
});