"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _FlexContext = _interopRequireDefault(require("./FlexContext"));

var _utils = require("../utils");

var _excluded = ["style", "className", "span", "children", "flex"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _createNamespace = (0, _utils.createNamespace)('flexitem'),
    _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
    bem = _createNamespace2[0];

var FlexItem = function FlexItem(props) {
  var style = props.style,
      className = props.className,
      span = props.span,
      children = props.children,
      flex = props.flex,
      others = (0, _objectWithoutProperties2().default)(props, _excluded);
  var classes = (0, _classnames().default)(bem([span === null || span === void 0 ? void 0 : span.toString()]), className);

  var parseFlex = function parseFlex(_flex) {
    if (typeof _flex === 'number') {
      return "".concat(_flex, " ").concat(_flex, " auto");
    }

    if (/^\d+(\.\d+)?(px|em|rem|%)$/.test(_flex)) {
      return "0 0 ".concat(_flex);
    }

    return _flex;
  };

  return /*#__PURE__*/_react().default.createElement(_FlexContext.default.Consumer, null, function (_ref) {
    var gutter = _ref.gutter;

    var mergedStyle = _objectSpread({}, style);

    if (gutter) {
      mergedStyle = _objectSpread(_objectSpread(_objectSpread({}, gutter[0] > 0 ? {
        paddingLeft: gutter[0] / 2,
        paddingRight: gutter[0] / 2
      } : {}), gutter[1] > 0 ? {
        paddingTop: gutter[1] / 2,
        paddingBottom: gutter[1] / 2
      } : {}), mergedStyle);
    }

    if (flex) {
      mergedStyle.flex = parseFlex(flex);
    }

    return /*#__PURE__*/_react().default.createElement("div", (0, _extends2().default)({}, others, {
      style: mergedStyle,
      className: classes
    }), children);
  });
};

var _default = FlexItem;
exports.default = _default;