"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _useMergedState3 = _interopRequireDefault(require("../hooks/use-merged-state"));

var _RadioContext = _interopRequireDefault(require("./RadioContext"));

var _utils = require("../utils");

/* eslint-disable no-console */
var _createNamespace = (0, _utils.createNamespace)('radio-group'),
    _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
    bem = _createNamespace2[0];

var RadioGroup = function RadioGroup(props) {
  var _useMergedState = (0, _useMergedState3.default)({
    value: props.value,
    defaultValue: props.defaultValue
  }),
      _useMergedState2 = (0, _slicedToArray2().default)(_useMergedState, 2),
      checked = _useMergedState2[0],
      setChecked = _useMergedState2[1];

  var toggle = function toggle(name) {
    var _props$onChange;

    setChecked(name);
    (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, name);
  };

  return /*#__PURE__*/_react().default.createElement(_RadioContext.default.Provider, {
    value: {
      parent: {
        props: props
      },
      toggle: toggle,
      checked: checked
    }
  }, /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(props.className, bem([props.direction])),
    style: props.style,
    role: "radiogroup"
  }, props.children));
};

var _default = RadioGroup;
exports.default = _default;